#include <stdio.h>
#include <stdlib.h>
#include <string.h>


void createOffsets()
{
    //int AA = -1431655766;

    FILE* blueStartFile = fopen("blueStart.bin","rb");
    FILE* purpleStartFile = fopen("purpleStart.bin","rb");

    int blue = -1455865449;
    int purple = -1319524039;

    fread(&blue,4,1,blueStartFile);
    fread(&purple,4,1,purpleStartFile);

    printf("\nblue: %d",blue);
    printf("\npurple: %d\n",purple);

    fclose(blueStartFile);
    fclose(purpleStartFile);


    FILE* fp = fopen("base.dds","rb");
    FILE* bin = fopen("offsets.bin","wb");

    int buffer = -1;

    fseek(fp,30* sizeof(int) ,SEEK_SET);


    long start = 0;
    long end = 0;
    long length = 0;
    int count = 0;
    int allowCounting = 0;
    int totalLength = 0;

    while (fread(&buffer,4,1,fp))
    {
        if (buffer == blue)
        {
            if (length == 0)
            {
                start = ftell(fp) - 4;
            }
            allowCounting = 1;
        }
        else if (buffer == purple)
        {
            if (length > 0)
            {
                count++;
                end = ftell(fp);

                length = end - start;
                printf("%d - start: %ld end: %ld lenth: %ld\n",count, start, end, length);

                fwrite(&start,sizeof(long),1,bin);
                fwrite(&length,sizeof(long),1,bin);

                totalLength += length;
            }
            length = 0;
            allowCounting = 0;
        }
        if (allowCounting)
        {
            length++;
        }
    }
    printf("\nTotal length: %d", totalLength);
    fclose(fp);
    fclose(bin);
}

typedef struct
{
    long value;
    long length;
} PubicHairOffset;

void createDDSBin(char* pathToDDS)
{
    FILE* ddsFile = fopen(pathToDDS,"rb");
    if (!ddsFile) exit(1);

    int lastIDX = strlen(pathToDDS) - 1;

    char* pathToBin = (char*) malloc(strlen(pathToDDS));
    strcpy(pathToBin,pathToDDS);
    pathToBin[lastIDX-2] = 'b';
    pathToBin[lastIDX-1] = 'i';
    pathToBin[lastIDX] = 'n';

    FILE* binFile = fopen(pathToBin,"wb");
    if (!binFile) exit(2);


    FILE* offsetFile = fopen("offsets.bin","rb");
    if (!offsetFile) exit(3);

    int i = 0;
    char buffer;
    PubicHairOffset offset;

    while(fread(&offset,sizeof(PubicHairOffset),1,offsetFile))
    {
        printf("\n%ld %ld", offset.value, offset.length);
        fseek(ddsFile,offset.value,SEEK_SET);

        fwrite(&offset.value,sizeof(long),1,binFile);
        fwrite(&offset.length,sizeof(long),1,binFile);

        for (i = 0; i < offset.length; i++)
        {
            fread(&buffer,1,1,ddsFile);
            fwrite(&buffer,1,1,binFile);
        }
    }
    fclose(ddsFile);
    fclose(offsetFile);
    fclose(binFile);
}

void reconstructDDS(char* pathToBin, char* pathToDDS)
{
    FILE* ddsFile = fopen(pathToDDS,"rb+");
    if (!ddsFile) exit(1);

    FILE* binFile = fopen(pathToBin,"rb");
    if (!binFile) exit(2);

    int i = 0;
    char buffer;
    PubicHairOffset offset;

     while(fread(&offset,sizeof(PubicHairOffset),1,binFile))
     {
        fseek(ddsFile,offset.value,SEEK_SET);

        for (i = 0; i < offset.length; i++)
        {
            fread(&buffer,1,1,binFile);
            fwrite(&buffer,1,1,ddsFile);
        }
     }

    fclose(ddsFile);
    fclose(binFile);
}

int main()
{
    createOffsets();
    createDDSBin("base.dds");
    reconstructDDS("base.bin","purple.dds");
    return 0;
}
