#include <stdio.h>
#include <stdlib.h>
#include <string.h>


long getFileSize(FILE* fp)
{
    long backup = ftell(fp);
    fseek(fp,0,SEEK_END);
    long size = ftell(fp);
    fseek(fp,backup,SEEK_SET);
    return size;
}

int main()
{
    system("copy /y \"shaved_backup.dds\" \"shaved.dds\"");

    FILE* shavedFile = fopen("shaved.dds","rb+");
    if (!shavedFile) exit(1);


    FILE* pubicFile = fopen("pubic.dds","rb+");
    if (!pubicFile) exit(2);

    if (getFileSize(shavedFile) != getFileSize(pubicFile))
    {
        printf("\nDifferent sizes.");
        printf("\n\n");
        system("PAUSE");
        exit(-1);
    }

    FILE* binFile = fopen("offsets.bin","wb+");
    if (!binFile) exit(3);


    long bufferShavedFile;
    long bufferPubicFile;

    long differentBytes = 0;

    while(fread(&bufferPubicFile,sizeof(long),1,pubicFile))
    {
        fread(&bufferShavedFile,sizeof(long),1,shavedFile);

        //printf("\n%ld %ld", bufferShavedFile, bufferPubicFile);

        if (bufferPubicFile != bufferShavedFile)
        {
            long offset = ftell(pubicFile) - sizeof(long);
            fwrite(&offset,sizeof(long),1,binFile);
            fwrite(&bufferPubicFile,sizeof(long),1,binFile);
            differentBytes++;
        }
    }

    printf("\n(%ld/%ld)", differentBytes, getFileSize(pubicFile));

    fclose(shavedFile);
    fclose(pubicFile);
    fclose(binFile);

    return 0;
}
