#include <stdio.h>
#include <stdlib.h>
#include <string.h>


long getFileSize(FILE* fp)
{
    long backup = ftell(fp);
    fseek(fp,0,SEEK_END);
    long size = ftell(fp);
    fseek(fp,backup,SEEK_SET);
    return size;
}

int main()
{
    system("copy /y \"shaved_backup.dds\" \"shaved.dds\"");

    FILE* shavedFile = fopen("shaved.dds","rb+");
    if (!shavedFile) exit(1);


    FILE* pubicFile = fopen("pubic.dds","rb+");
    if (!pubicFile) exit(2);

    if (getFileSize(shavedFile) != getFileSize(pubicFile))
    {
        printf("\nDifferent sizes.");
        printf("\n\n");
        system("PAUSE");
        exit(-1);
    }

    FILE* binFile = fopen("offsets.bin","wb+");
    if (!binFile) exit(3);


    long offsetStart = 0;
    long offsetEnd = 0;

    long same = 0;

    long bufferShavedFile;
    long bufferPubicFile;

    long differentBytes = 0;

    int blockStarted = 0;

    while(fread(&bufferPubicFile,sizeof(long),1,pubicFile))
    {
        fread(&bufferShavedFile,sizeof(long),1,shavedFile);

        if (bufferPubicFile != bufferShavedFile)
        {
            offsetStart = ftell(pubicFile) - sizeof(long);
            blockStarted = 1;
            same = 0;
        }
        if ((bufferPubicFile == bufferShavedFile))
        {
            if (same > 4 && blockStarted)
            {
                printf("\noffsetStart: %ld", offsetStart);

                offsetEnd = ftell(pubicFile) - sizeof(long);

                printf("\noffsetEnd: %ld", offsetEnd);

                fwrite(&offsetStart,sizeof(long),1,binFile);
                fwrite(&offsetEnd,sizeof(long),1,binFile);

                long length = offsetEnd - offsetStart;

                printf("\nlength: %ld", length);

                printf("\nbefore seek: %ld", ftell(pubicFile));
                fseek(pubicFile,offsetStart,SEEK_SET);

                char* newBuffer = (char*) malloc(length);

                fread(newBuffer,length,1,pubicFile);
                fwrite(newBuffer,length,1,binFile);

                fread(&bufferPubicFile,sizeof(long),1,pubicFile);

                printf("\nafter seek: %ld", ftell(pubicFile));

                free(newBuffer);

                blockStarted = 0;

                 printf("\n\n");
                system("PAUSE");
            }


            same++;

        }
    }

    printf("\n(%ld/%ld)", differentBytes, getFileSize(pubicFile));

    fclose(shavedFile);
    fclose(pubicFile);
    fclose(binFile);

    return 0;
}
